
local tUniqueImpPlots = {}; 
local tUniqueImpIDplayerID = {};  
local tPillagedPlots = {}; 
local tBuggedCivs = {'CIVILIZATION_NUBIA', 'CIVILIZATION_INDONESIA', 'CIVILIZATION_PERSIA', 'CIVILIZATION_SCOTLAND', 'CIVILIZATION_CREE', 'CIVILIZATION_NETHERLANDS'};
local tBuggedImps = {'IMPROVEMENT_PYRAMID', 'IMPROVEMENT_KAMPUNG', 'IMPROVEMENT_PAIRIDAEZA', 'IMPROVEMENT_GOLF_COURSE', 'IMPROVEMENT_MEKEWAP', 'IMPROVEMENT_POLDER'};
local tBuggedImpIDplayerID = {}; -- imp that need fix
local iNewCityID = -1;


local function GetUniqueImpType(iPlayer)

	local sCivType = PlayerConfigurations[iPlayer]:GetCivilizationTypeName();

	for row in GameInfo.NSUI_CivType_UniqueImpType() do
		if row.CivType == sCivType then
			return GameInfo.Improvements[row.UniqueImpType].Index;
		end
	end
		
	return -1;
end


local function OnCityTransfered( iPlayerID, iCityID )

	if iCityID ~= iNewCityID then
		CleanUp();
		return;
	end

	local pCity = Players[iPlayerID]:GetCities():FindID( iCityID );
	-- local pCityPlot = Map.GetPlot(pCity:GetX(), pCity:GetY());	
	-- local iCityPlotID = pCityPlot:GetIndex();
	print("OnCityTransfered ",pCity:GetName(), iCityID);

	for pPlot, iUniqueImpType in pairs(tUniqueImpPlots) do
		print("Placing ", GameInfo.Improvements[iUniqueImpType].ImprovementType, pPlot:GetX(), pPlot:GetY() );

		if tBuggedImpIDplayerID[iUniqueImpType] then
			ImprovementBuilder.SetImprovementType(pPlot, iUniqueImpType, tBuggedImpIDplayerID[iUniqueImpType]);
			print("bugged improvement, set owner to original civ !!!!!!!!!!");
		else
			ImprovementBuilder.SetImprovementType(pPlot, iUniqueImpType, iPlayerID);
		end

		if tPillagedPlots[pPlot] == 1 then
			ImprovementBuilder.SetImprovementPillaged(pPlot, true);
		end
	end

	CleanUp();
end


local function OnImprovementOwnershipChanged(iX, iY, iImpType, iImpOwner, resource, iIsPillaged, isWorked)
	local sImpName = GameInfo.Improvements[iImpType].ImprovementType;
	print('OnImprovementOwnershipChanged', iX, iY, sImpName, iIsPillaged);
	
	if tUniqueImpIDplayerID[iImpType] then
		local pPlot = Map.GetPlot(iX, iY);	
		print(' Unique Improvement Ownership Changed', iX, iY, sImpName);
		tUniqueImpPlots[pPlot] = iImpType;
		tPillagedPlots[pPlot] = iIsPillaged; -- integer
	end
end


function CleanUp()
	print("NSUI CleanUp ");
	Events.ImprovementOwnershipChanged.Remove(OnImprovementOwnershipChanged );
	Events.CityTransfered.Remove(OnCityTransfered );
	tPillagedPlots = {};
	tUniqueImpPlots = {};
	iNewCityID = -1;
end

-- fires when city conquered, gifted, changes owner because of loyalty
local function OnCityBuilt( iPlayerID, iCityID, iX, iY )	
	local pCity = Players[iPlayerID]:GetCities():FindID( iCityID );

	if pCity:GetOriginalOwner() ~= pCity:GetOwner() then
		print("OnCityBuilt new owner", pCity:GetName(), pCity:GetOriginalOwner(), pCity:GetOwner(), iCityID);
		iNewCityID = iCityID;
		Events.ImprovementOwnershipChanged.Add( OnImprovementOwnershipChanged );
		Events.CityTransfered.Add( OnCityTransfered);
	end
end


local function Initialize()
	GameEvents.CityBuilt.Add(OnCityBuilt); 

	for iPlayerID, pPlayer in  ipairs(Players) do
		-- if pPlayer:WasEverAlive() and pPlayer:IsAlive() then
		if pPlayer:WasEverAlive() then
			local iUniqueImp = GetUniqueImpType(iPlayerID);
			local sCivName = PlayerConfigurations[iPlayerID]:GetCivilizationTypeName();
			print( sCivName, iPlayerID);

			if iUniqueImp > -1 then

				tUniqueImpIDplayerID[iUniqueImp] = iPlayerID;
				print('iUniqueImp', sCivName, iPlayerID, GameInfo.Improvements[iUniqueImp].ImprovementType, iUniqueImp);

				for _, value in pairs(tBuggedCivs) do
					if value == sCivName then
						tBuggedImpIDplayerID[iUniqueImp] = iPlayerID;
						-- print( ' bugged ', sCivName, GameInfo.Improvements[iUniqueImp].ImprovementType, iUniqueImp);
						break;
					end
				end
			end
		end
	end

	print( ' NSUI LOADED ');
end
Events.LoadScreenClose.Add(Initialize);


-- function OnCityAddedToMap( iPlayerID: number, iCityID : number, iX : number, iY : number )
	-- local pCity = Players[iPlayerID]:GetCities():FindID( iCityID );
	-- print("OnCityAddedToMap ", pCity:GetName(), pCity:GetOriginalOwner(), pCity:GetOwner(), iCityID);
-- end

-- function OnImprovementAddedToMap(iX, iY, iImpType, iImpOwner, resource, isPillaged, isWorked)
	-- print("OnImprovementAddedToMap ", GameInfo.Improvements[iImpType].ImprovementType);
-- end

-- function OnImprovementAddedToMap(iX, iY, iImpType, iImpOwner, resource, isPillaged, isWorked)
	-- local sImpName = GameInfo.Improvements[iImpType].ImprovementType;
	-- print('OnImprovementAddedToMap', iX, iY, sImpName);
-- end

-- function OnImprovementChanged(iX, iY, iImpType, iImpOwner, resource, isPillaged, isWorked)
	-- local sImpName = GameInfo.Improvements[iImpType].ImprovementType;
	-- print('OnImprovementChanged', iX, iY, sImpName);
-- end

-- function OnCityCommandStarted( cityOwnerID: number, cityID :number, districtOwnerID :number, districtID :number, commandType :number, iData1 :number )
	-- print("OnCityCommandStarted ");
-- end

-- function OnCityDefenseStatusChanged(playerID, iValue)
	-- print("OnCityDefenseStatusChanged ");
-- end

-- function OnCityLiberated(playerID:number, cityID:number)
	-- print("OnCityLiberated ");
-- end

-- function OnCityLoyaltyChanged( playerID: number, cityID: number )
	-- print("OnCityLoyaltyChanged ");
-- end

-- function OnCityChanged( playerID: number, cityID : number, cityX : number, cityY : number )	
	-- print("OnCityChanged ");
-- end

-- function OnCityOccupationChanged( playerID: number, cityID : number )
	-- print("OnCityOccupationChanged ");
-- end

-- function OnCityRemovedFromMap( playerID: number, cityID : number )
	-- print("OnCityRemovedFromMap ",cityID);
-- end

-- function OnCitySiegeStatusChanged( playerID: number, cityID : number )
	-- print("OnCitySiegeStatusChanged ");
-- end

-- local function OnCityConquered(iCapturerID, iOwnerID, iCityID , iCityX, iCityY)
	-- local pCity = Players[iCapturerID]:GetCities():FindID( iCityID );
	-- print(pCity:GetName(), ' Conquered', iCityID);
-- end

-- function OnCityBuilt( playerID: number, cityID : number, cityX : number, cityY : number )
	-- local pCity = Players[playerID]:GetCities():FindID( cityID );
	-- print("OnCityBuilt  " .. pCity:GetName());

-- end
-- GameEvents.CityBuilt.Add(OnCityBuilt );


-- function OnCityAddedToMap(playerID, cityID, x, y)
	-- local pCity = Players[playerID]:GetCities():FindID( cityID );
	-- print("CityAddedToMap  " .. pCity:GetName());
-- end
-- Events.CityAddedToMap.Add( OnCityAddedToMap );
