
CREATE TABLE "NSUI_CivType_UniqueImpType" (
		"CivType" TEXT NOT NULL,
		"UniqueImpType" TEXT NOT NULL);

INSERT INTO NSUI_CivType_UniqueImpType ( CivType, UniqueImpType )
 SELECT a.CivilizationType, b.ImprovementType FROM CivilizationTraits AS a, Improvements AS b WHERE a.TraitType IS b.TraitType AND a.CivilizationType != 'CIVILIZATION_BARBARIAN';

INSERT INTO NSUI_CivType_UniqueImpType ( CivType, UniqueImpType ) -- minor civs improvements
 SELECT CivilizationLeadersTable.CivilizationType, ImprovementsTable.ImprovementType FROM LeaderTraits AS LeaderTraitsTable, Improvements AS ImprovementsTable, CivilizationLeaders AS CivilizationLeadersTable WHERE LeaderTraitsTable.TraitType IS ImprovementsTable.TraitType AND LeaderTraitsTable.LeaderType IS CivilizationLeadersTable.LeaderType AND LeaderTraitsTable.LeaderType LIKE 'LEADER_MINOR_CIV_%';

-- SELECT ImprovementType, TraitType FROM Improvements;

-- CASE WHEN instr(Name, 'LOC_') = 0 THEN 'Remove '||Name ELSE 'LOC_PROJECT_REMOVE'||substr(Name, 4) END,

 -- allow minor civ build their unique improvement
INSERT INTO TraitModifiers (TraitType, ModifierId)
VALUES ('MINOR_CIV_LA_VENTA_TRAIT', 'MINOR_CIV_LA_VENTA_CAN_COLLOSSAL_HEAD');

INSERT INTO TraitModifiers (TraitType, ModifierId) -- GS minor civ
SELECT 'MINOR_CIV_CAHOKIA_TRAIT', 'MINOR_CIV_CAHOKIA_CAN_MOUND' 
WHERE EXISTS ( SELECT CivilizationType FROM Civilizations WHERE CivilizationType IS 'CIVILIZATION_CAHOKIA');
 
INSERT INTO TraitModifiers (TraitType, ModifierId) -- GS minor civ
SELECT 'MINOR_CIV_NAZCA_TRAIT', 'MINOR_CIV_NAZCA_CAN_NAZCA_LINE' 
WHERE EXISTS ( SELECT CivilizationType FROM Civilizations WHERE CivilizationType IS 'CIVILIZATION_NAZCA');
 
INSERT INTO TraitModifiers (TraitType, ModifierId) -- GS minor civ
SELECT 'MINOR_CIV_RAPA_NUI_TRAIT', 'MINOR_CIV_RAPA_NUI_CAN_MOAI' 
WHERE EXISTS ( SELECT CivilizationType FROM Civilizations WHERE CivilizationType IS 'CIVILIZATION_RAPA_NUI');

INSERT INTO TraitModifiers (TraitType, ModifierId) -- vikings DLC
SELECT 'MINOR_CIV_ARMAGH_TRAIT', 'MINOR_CIV_ARMAGH_UNLOCK_MONASTERY_BONUS' 
WHERE EXISTS ( SELECT CivilizationType FROM Civilizations WHERE CivilizationType IS 'CIVILIZATION_ARMAGH');

INSERT INTO TraitModifiers (TraitType, ModifierId) -- vikings DLC
SELECT 'MINOR_CIV_GRANADA_TRAIT', 'MINOR_CIV_GRANADA_UNLOCK_ALCAZAR_BONUS' 
WHERE EXISTS ( SELECT CivilizationType FROM Civilizations WHERE CivilizationType IS 'CIVILIZATION_GRANADA');



